#!/usr/bin/python
import classGraph as Graph
import pdb

parameters = {}
parameters['graph_filename']='../kinship/data.bmg'
parameters['out_rep']='../results/'
parameters['sdesc']=1
parameters['max_paths']=1000000
parameters['max_time']=60
parameters['try_extend']=1
parameters['try_init']=5 # 3
parameters['alt_longer']=2 # 3
parameters['min_examples']=3
parameters['thres_support']=0.2
parameters['thres_acc']=1
parameters['max_eq']=4
parameters['max_nd']=10
parameters['combine_paths'] = True
parameters['include_supers'] = False #True
parameters['prune_idems'] = True
parameters['limit_pattern'] = 0
parameters['id_exp'] = "tmp"
parameters['relevant_atts'] = {1: {'sex':'cat', 'age':'num', 'relevant':'cat'}, 0: {'genealink':'cat', 'kinlink':'cat'}}

fp = open(parameters['graph_filename'])
graph = Graph.Graph.readBMG(fp, parameters['relevant_atts'])
fp.close()

supports = {}
indices = {}
fp=open("../results/supports.txt")
for line in fp:
    parts = line.split('\t')
    key_p = tuple(parts[0].split("_"))
    supports[key_p] = set(parts[1].split() + parts[2].split())
    indices[key_p] = [(v,i) for (i,v) in enumerate(parts[1].split() + parts[2].split())]
    indices[key_p].sort()

supports_keys = supports.keys() 
overlaps = {}
jaccs = {}
for si, skA in enumerate(supports_keys):
    for skB in supports_keys[:si]:
        overlaps[(skA, skB)] = supports[skA] & supports[skB]
        jaccs[(skA, skB)] = len(overlaps[(skA, skB)])/float(len(supports[skA]) + len(supports[skB]) - len(overlaps[(skA, skB)]))

pairs = [p for p,j in jaccs.items() if j > 0.9]
pairs.sort(key = lambda x:jaccs[x], reverse=True)

switch_sides = {'A': 'Z', 'Z': 'A'}

for (skA, skB) in pairs:
    okA = (skA[0], switch_sides[skA[1]], skA[2])
    okB = (skB[0], switch_sides[skB[1]], skB[2])
    symmetric_pair = (okA, okB) 
    if skA[0] != skB[0] and symmetric_pair not in pairs:
        edges = []
        back_A = 0; front_A = 0; back_B = 0; front_B = 0
        while front_A < len(indices[skA]) and front_B < len(indices[skB]):
            if indices[skA][front_A][0] < indices[skB][front_B][0]:
                front_A += 1
            elif indices[skA][front_A][0] > indices[skB][front_B][0]:
                front_B += 1
            else:
                back_A = front_A; back_B = front_B
                front_A+=1; front_B+=1
                while front_A <= len(indices[skA]) and indices[skA][front_A-1][0] == indices[skA][back_A][0]:                    
                    front_A +=1
                while front_B <= len(indices[skB]) and indices[skB][front_B-1][0] == indices[skB][back_B][0]:
                    front_B +=1
                for (vA, pA) in indices[skA][back_A:front_A]:
                    for (vB, pB) in indices[skB][back_B:front_B]:
                        edges.append((indices[okA][pA][0], indices[okB][pB][0]))

        print "%s %s %f %d %d %d %d %d" % ('_'.join(skA), '_'.join(skB), jaccs[skA, skB], len(overlaps[(skA, skB)]), len(supports[skA]), len(supports[skB]), len(edges), len(set(edges)))
        if len(set(edges)) < 150:

            inv_att = {0: dict(parameters['relevant_atts'][0]),
                       1: dict(parameters['relevant_atts'][1])}
            del inv_att[0]['kinlink']
            
            parameters['id_exp'] = "%s-%s" % ('_'.join(skA), '_'.join(skB))

            essential, details = graph.searchPattern(edges, inv_att, parameters)
            if len(details['covert_patts']) > 0:
                Graph.Graph.writeShortResults(parameters, edges, details)
            
